Leetcode Regular Expression Matching Java Solution

Given an input string (s) and a pattern (p), implement regular expression matching with support for '.' and '*'.

'.' Matches any single character.
'*' Matches zero or more of the preceding element.

The matching should cover the entire input string (not partial).

Note:

  • s could be empty and contains only lowercase letters a-z.
  • p could be empty and contains only lowercase letters a-z, and characters like . or *.

Example 1:

Input:
s = "aa"
p = "a"
Output: false
Explanation: "a" does not match the entire string "aa".

Example 2:

Input:
s = "aa"
p = "a*"
Output: true
Explanation: '*' means zero or more of the preceding element, 'a'. Therefore, by repeating 'a' once, it becomes "aa".

Example 3:

Input:
s = "ab"
p = ".*"
Output: true
Explanation: ".*" means "zero or more (*) of any character (.)".

Example 4:

Input:
s = "aab"
p = "c*a*b"
Output: true
Explanation: c can be repeated 0 times, a can be repeated 1 time. Therefore, it matches "aab".

Example 5:

Input:
s = "mississippi"
p = "mis*is*p*."
Output: false

Solution:

Explanation:

1, init dp[0][0] && dp[0][j], to avoid corner cases;
2, transform function:
a, when p == ‘‘:
compare char[i-1][j-1];
if same, “char
” can count as 0, 1, multiple;
Important: if multiple, dp[i+ 1][j+ 1] = dp[i][j+1];
think backwards, not forwards.

Or simplify:
dp[i][j+1] represents 1/multiple, think previous step, represents 0 or multiple
dp[i+ 1][j+ 1] = dp[i + 1][j – 1] || dp[i][j] || dp[i][j+1]; // count 0, 1, multiple
here, counting 1 is redundant
So we can just use
dp[i+ 1][j+ 1] = dp[i + 1][j – 1] || dp[i][j+1]

class HackerHeap {
    public boolean isMatch(String s, String p) {
        int m = s.length(), n = p.length();
        if (n == 0) return m == 0;
        boolean[][] dp = new boolean[m + 1][n + 1];
        dp[0][0] = true;
        for (int i = 1; i < n; i+=2) {
            if (p.charAt(i) != '*') break;
            else dp[0][i + 1] = true;
        }
        
        for (int i = 0; i < m; i++) {
            for (int j = 0; j < n; j++) {
                char a = s.charAt(i), b = p.charAt(j);
                if (b == '.' || a == b) dp[i + 1][j + 1] = dp[i][j];
                else if (b == '*') dp[i + 1][j + 1] = dp[i + 1][j - 1]  // zero
                    || ((s.charAt(i) == p.charAt(j - 1) || p.charAt(j - 1) == '.') &&               dp[i][j + 1]); // 1 or more;  // consider ".*"
            }
        }
        
        return dp[m][n];
    }
}